diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-phpmailer.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-phpmailer.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-phpmailer.php	2012-06-25 22:54:17.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-phpmailer.php	2013-02-28 12:33:13.000000000 -0600
***************
*** 2,8 ****
  /*~ class.phpmailer.php
  .---------------------------------------------------------------------------.
  |  Software: PHPMailer - PHP email class                                    |
! |   Version: 5.2.1                                                          |
  |      Site: https://code.google.com/a/apache-extras.org/p/phpmailer/       |
  | ------------------------------------------------------------------------- |
  |     Admin: Jim Jagielski (project admininistrator)                        |
--- 2,8 ----
  /*~ class.phpmailer.php
  .---------------------------------------------------------------------------.
  |  Software: PHPMailer - PHP email class                                    |
! |   Version: 5.2.4                                                          |
  |      Site: https://code.google.com/a/apache-extras.org/p/phpmailer/       |
  | ------------------------------------------------------------------------- |
  |     Admin: Jim Jagielski (project admininistrator)                        |
***************
*** 23,29 ****
  */
  
  /**
!  * PHPMailer - PHP email transport class
   * NOTE: Requires PHP version 5 or later
   * @package PHPMailer
   * @author Andy Prevost
--- 23,29 ----
  */
  
  /**
!  * PHPMailer - PHP email creation and transport class
   * NOTE: Requires PHP version 5 or later
   * @package PHPMailer
   * @author Andy Prevost
***************
*** 31,42 ****
   * @author Jim Jagielski
   * @copyright 2010 - 2012 Jim Jagielski
   * @copyright 2004 - 2009 Andy Prevost
-  * @version $Id: class.phpmailer.php 450 2010-06-23 16:46:33Z coolbru $
   * @license http://www.gnu.org/copyleft/lesser.html GNU Lesser General Public License
   */
  
  if (version_compare(PHP_VERSION, '5.0.0', '<') ) exit("Sorry, this version of PHPMailer will only run on PHP version 5 or greater!\n");
  
  class PHPMailer {
  
    /////////////////////////////////////////////////
--- 31,45 ----
   * @author Jim Jagielski
   * @copyright 2010 - 2012 Jim Jagielski
   * @copyright 2004 - 2009 Andy Prevost
   * @license http://www.gnu.org/copyleft/lesser.html GNU Lesser General Public License
   */
  
  if (version_compare(PHP_VERSION, '5.0.0', '<') ) exit("Sorry, this version of PHPMailer will only run on PHP version 5 or greater!\n");
  
+ /**
+  * PHP email creation and transport class
+  * @package PHPMailer
+  */
  class PHPMailer {
  
    /////////////////////////////////////////////////
***************
*** 94,99 ****
--- 97,109 ----
    public $Sender            = '';
  
    /**
+    * Sets the Return-Path of the message.  If empty, it will
+    * be set to either From or Sender.
+    * @var string
+    */
+   public $ReturnPath        = '';
+ 
+   /**
     * Sets the Subject of the message.
     * @var string
     */
***************
*** 130,140 ****
    protected $MIMEHeader     = '';
  
    /**
!    * Stores the complete sent MIME message (Body and Headers)
     * @var string
     * @access protected
    */
!   protected $SentMIMEMessage     = '';
  
    /**
     * Sets word wrapping on the body of the message to a given number of
--- 140,150 ----
    protected $MIMEHeader     = '';
  
    /**
!    * Stores the extra header list which CreateHeader() doesn't fold in
     * @var string
     * @access protected
    */
!   protected $mailHeader     = '';
  
    /**
     * Sets word wrapping on the body of the message to a given number of
***************
*** 156,161 ****
--- 166,178 ----
    public $Sendmail          = '/usr/sbin/sendmail';
  
    /**
+    * Determine if mail() uses a fully sendmail compatible MTA that
+    * supports sendmail's "-oi -f" options
+    * @var boolean
+    */
+   public $UseSendmailOptions	= true;
+   
+   /**
     * Path to PHPMailer plugins.  Useful if the SMTP class
     * is in a different directory than the PHP include path.
     * @var string
***************
*** 183,194 ****
     */
    public $MessageID         = '';
  
    /////////////////////////////////////////////////
    // PROPERTIES FOR SMTP
    /////////////////////////////////////////////////
  
    /**
!    * Sets the SMTP hosts.  All hosts must be separated by a
     * semicolon.  You can also specify a different port
     * for each host by using this format: [hostname:port]
     * (e.g. "smtp1.example.com:25;smtp2.example.com").
--- 200,220 ----
     */
    public $MessageID         = '';
  
+   /**
+    * Sets the message Date to be used in the Date header.
+    * If empty, the current date will be added.
+    * @var string
+    */
+   public $MessageDate       = '';
+ 
    /////////////////////////////////////////////////
    // PROPERTIES FOR SMTP
    /////////////////////////////////////////////////
  
    /**
!    * Sets the SMTP hosts.
!    *
!    * All hosts must be separated by a
     * semicolon.  You can also specify a different port
     * for each host by using this format: [hostname:port]
     * (e.g. "smtp1.example.com:25;smtp2.example.com").
***************
*** 210,217 ****
    public $Helo          = '';
  
    /**
!    * Sets connection prefix.
!    * Options are "", "ssl" or "tls"
     * @var string
     */
    public $SMTPSecure    = '';
--- 236,242 ----
    public $Helo          = '';
  
    /**
!    * Sets connection prefix. Options are "", "ssl" or "tls"
     * @var string
     */
    public $SMTPSecure    = '';
***************
*** 235,240 ****
--- 260,283 ----
    public $Password      = '';
  
    /**
+    *  Sets SMTP auth type. Options are LOGIN | PLAIN | NTLM  (default LOGIN)
+    *  @var string
+    */
+   public $AuthType      = '';
+   
+   /**
+    *  Sets SMTP realm.
+    *  @var string
+    */
+   public $Realm         = '';
+ 
+   /**
+    *  Sets SMTP workstation.
+    *  @var string
+    */
+   public $Workstation   = '';
+ 
+   /**
     * Sets the SMTP server timeout in seconds.
     * This function will not work with the win32 version.
     * @var int
***************
*** 248,253 ****
--- 291,303 ----
    public $SMTPDebug     = false;
  
    /**
+    * Sets the function/method to use for debugging output.
+    * Right now we only honor "echo" or "error_log"
+    * @var string
+    */
+   public $Debugoutput     = "echo";
+ 
+   /**
     * Prevents the SMTP connection from being closed after each mail
     * sending.  If this is set to true then to close the connection
     * requires an explicit call to SmtpClose().
***************
*** 269,321 ****
    public $SingleToArray = array();
  
   /**
!    * Provides the ability to change the line ending
     * @var string
     */
    public $LE              = "\n";
  
!   /**
!    * Used with DKIM DNS Resource Record
     * @var string
     */
!   public $DKIM_selector   = 'phpmailer';
  
    /**
!    * Used with DKIM DNS Resource Record
!    * optional, in format of email address 'you@yourdomain.com'
     * @var string
     */
    public $DKIM_identity   = '';
  
    /**
!    * Used with DKIM DNS Resource Record
     * @var string
     */
    public $DKIM_passphrase   = '';
  
    /**
!    * Used with DKIM DNS Resource Record
!    * optional, in format of email address 'you@yourdomain.com'
     * @var string
     */
    public $DKIM_domain     = '';
  
    /**
!    * Used with DKIM DNS Resource Record
!    * optional, in format of email address 'you@yourdomain.com'
     * @var string
     */
    public $DKIM_private    = '';
  
    /**
!    * Callback Action function name
!    * the function that handles the result of the send email action. Parameters:
     *   bool    $result        result of the send action
     *   string  $to            email address of the recipient
     *   string  $cc            cc email addresses
     *   string  $bcc           bcc email addresses
     *   string  $subject       the subject
     *   string  $body          the email body
     * @var string
     */
    public $action_function = ''; //'callbackAction';
--- 319,387 ----
    public $SingleToArray = array();
  
   /**
!    * Provides the ability to change the generic line ending
!    * NOTE: The default remains '\n'. We force CRLF where we KNOW
!    *        it must be used via self::CRLF
     * @var string
     */
    public $LE              = "\n";
  
!    /**
!    * Used with DKIM Signing
!    * required parameter if DKIM is enabled
!    *
!    * domain selector example domainkey
     * @var string
     */
!   public $DKIM_selector   = '';
  
    /**
!    * Used with DKIM Signing
!    * required if DKIM is enabled, in format of email address 'you@yourdomain.com' typically used as the source of the email
     * @var string
     */
    public $DKIM_identity   = '';
  
    /**
!    * Used with DKIM Signing
!    * optional parameter if your private key requires a passphras
     * @var string
     */
    public $DKIM_passphrase   = '';
  
    /**
!    * Used with DKIM Singing
!    * required if DKIM is enabled, in format of email address 'domain.com'
     * @var string
     */
    public $DKIM_domain     = '';
  
    /**
!    * Used with DKIM Signing
!    * required if DKIM is enabled, path to private key file
     * @var string
     */
    public $DKIM_private    = '';
  
    /**
!    * Callback Action function name.
!    * The function that handles the result of the send email action.
!    * It is called out by Send() for each email sent.
!    *
!    * Value can be:
!    * - 'function_name' for function names
!    * - 'Class::Method' for static method calls
!    * - array($object, 'Method') for calling methods on $object
!    * See http://php.net/is_callable manual page for more details.
!    *
!    * Parameters:
     *   bool    $result        result of the send action
     *   string  $to            email address of the recipient
     *   string  $cc            cc email addresses
     *   string  $bcc           bcc email addresses
     *   string  $subject       the subject
     *   string  $body          the email body
+    *   string  $from          email address of sender
     * @var string
     */
    public $action_function = ''; //'callbackAction';
***************
*** 324,334 ****
     * Sets the PHPMailer Version number
     * @var string
     */
!   public $Version         = '5.2.1';
  
    /**
     * What to use in the X-Mailer header
!    * @var string
     */
    public $XMailer         = '';
  
--- 390,400 ----
     * Sets the PHPMailer Version number
     * @var string
     */
!   public $Version         = '5.2.4';
  
    /**
     * What to use in the X-Mailer header
!    * @var string NULL for default, whitespace for None, or actual string to use
     */
    public $XMailer         = '';
  
***************
*** 336,356 ****
    // PROPERTIES, PRIVATE AND PROTECTED
    /////////////////////////////////////////////////
  
!   protected   $smtp           = NULL;
    protected   $to             = array();
    protected   $cc             = array();
    protected   $bcc            = array();
    protected   $ReplyTo        = array();
    protected   $all_recipients = array();
    protected   $attachment     = array();
    protected   $CustomHeader   = array();
    protected   $message_type   = '';
    protected   $boundary       = array();
    protected   $language       = array();
    protected   $error_count    = 0;
    protected   $sign_cert_file = '';
    protected   $sign_key_file  = '';
    protected   $sign_key_pass  = '';
    protected   $exceptions     = false;
  
    /////////////////////////////////////////////////
--- 402,486 ----
    // PROPERTIES, PRIVATE AND PROTECTED
    /////////////////////////////////////////////////
  
!   /**
!    * @var SMTP An instance of the SMTP sender class
!    * @access protected
!    */
!   protected   $smtp           = null;
!   /**
!    * @var array An array of 'to' addresses
!    * @access protected
!    */
    protected   $to             = array();
+   /**
+    * @var array An array of 'cc' addresses
+    * @access protected
+    */
    protected   $cc             = array();
+   /**
+    * @var array An array of 'bcc' addresses
+    * @access protected
+    */
    protected   $bcc            = array();
+   /**
+    * @var array An array of reply-to name and address
+    * @access protected
+    */
    protected   $ReplyTo        = array();
+   /**
+    * @var array An array of all kinds of addresses: to, cc, bcc, replyto
+    * @access protected
+    */
    protected   $all_recipients = array();
+   /**
+    * @var array An array of attachments
+    * @access protected
+    */
    protected   $attachment     = array();
+   /**
+    * @var array An array of custom headers
+    * @access protected
+    */
    protected   $CustomHeader   = array();
+   /**
+    * @var string The message's MIME type
+    * @access protected
+    */
    protected   $message_type   = '';
+   /**
+    * @var array An array of MIME boundary strings
+    * @access protected
+    */
    protected   $boundary       = array();
+   /**
+    * @var array An array of available languages
+    * @access protected
+    */
    protected   $language       = array();
+   /**
+    * @var integer The number of errors encountered
+    * @access protected
+    */
    protected   $error_count    = 0;
+   /**
+    * @var string The filename of a DKIM certificate file
+    * @access protected
+    */
    protected   $sign_cert_file = '';
+   /**
+    * @var string The filename of a DKIM key file
+    * @access protected
+    */
    protected   $sign_key_file  = '';
+   /**
+    * @var string The password of a DKIM key
+    * @access protected
+    */
    protected   $sign_key_pass  = '';
+   /**
+    * @var boolean Whether to throw exceptions for errors
+    * @access protected
+    */
    protected   $exceptions     = false;
  
    /////////////////////////////////////////////////
***************
*** 360,371 ****
    const STOP_MESSAGE  = 0; // message only, continue processing
    const STOP_CONTINUE = 1; // message?, likely ok to continue processing
    const STOP_CRITICAL = 2; // message, plus full stop, critical error reached
! 
    /////////////////////////////////////////////////
    // METHODS, VARIABLES
    /////////////////////////////////////////////////
  
    /**
     * Constructor
     * @param boolean $exceptions Should we throw external exceptions?
     */
--- 490,536 ----
    const STOP_MESSAGE  = 0; // message only, continue processing
    const STOP_CONTINUE = 1; // message?, likely ok to continue processing
    const STOP_CRITICAL = 2; // message, plus full stop, critical error reached
!   const CRLF = "\r\n";     // SMTP RFC specified EOL
!   
    /////////////////////////////////////////////////
    // METHODS, VARIABLES
    /////////////////////////////////////////////////
  
    /**
+    * Calls actual mail() function, but in a safe_mode aware fashion
+    * Also, unless sendmail_path points to sendmail (or something that
+    * claims to be sendmail), don't pass params (not a perfect fix,
+    * but it will do)
+    * @param string $to To
+    * @param string $subject Subject
+    * @param string $body Message Body
+    * @param string $header Additional Header(s)
+    * @param string $params Params
+    * @access private
+    * @return bool
+    */
+   private function mail_passthru($to, $subject, $body, $header, $params) {
+     if ( ini_get('safe_mode') || !($this->UseSendmailOptions) ) {
+         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($subject)), $body, $header);
+     } else {
+         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($subject)), $body, $header, $params);
+     }
+     return $rt;
+   }
+ 
+   /**
+    * Outputs debugging info via user-defined method
+    * @param string $str
+    */
+   private function edebug($str) {
+     if ($this->Debugoutput == "error_log") {
+         error_log($str);
+     } else {
+         echo $str;
+     }
+   }
+ 
+   /**
     * Constructor
     * @param boolean $exceptions Should we throw external exceptions?
     */
***************
*** 476,481 ****
--- 641,647 ----
     * @param string $kind One of 'to', 'cc', 'bcc', 'ReplyTo'
     * @param string $address The email address to send to
     * @param string $name
+    * @throws phpmailerException
     * @return boolean true on success, false if address already used or invalid in some way
     * @access protected
     */
***************
*** 485,504 ****
        if ($this->exceptions) {
          throw new phpmailerException('Invalid recipient array: ' . $kind);
        }
! 	  if ($this->SMTPDebug) {
!         echo $this->Lang('Invalid recipient array').': '.$kind;
        }
        return false;
      }
      $address = trim($address);
      $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
!     if (!self::ValidateAddress($address)) {
        $this->SetError($this->Lang('invalid_address').': '. $address);
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
! 	  if ($this->SMTPDebug) {
!         echo $this->Lang('invalid_address').': '.$address;
        }
        return false;
      }
--- 651,670 ----
        if ($this->exceptions) {
          throw new phpmailerException('Invalid recipient array: ' . $kind);
        }
!       if ($this->SMTPDebug) {
!         $this->edebug($this->Lang('Invalid recipient array').': '.$kind);
        }
        return false;
      }
      $address = trim($address);
      $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
!     if (!$this->ValidateAddress($address)) {
        $this->SetError($this->Lang('invalid_address').': '. $address);
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
!       if ($this->SMTPDebug) {
!         $this->edebug($this->Lang('invalid_address').': '.$address);
        }
        return false;
      }
***************
*** 521,538 ****
   * Set the From and FromName properties
   * @param string $address
   * @param string $name
   * @return boolean
   */
    public function SetFrom($address, $name = '', $auto = 1) {
      $address = trim($address);
      $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
!     if (!self::ValidateAddress($address)) {
        $this->SetError($this->Lang('invalid_address').': '. $address);
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
! 	  if ($this->SMTPDebug) {
!         echo $this->Lang('invalid_address').': '.$address;
        }
        return false;
      }
--- 687,706 ----
   * Set the From and FromName properties
   * @param string $address
   * @param string $name
+  * @param int $auto Also set Reply-To and Sender
+    * @throws phpmailerException
   * @return boolean
   */
    public function SetFrom($address, $name = '', $auto = 1) {
      $address = trim($address);
      $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
!     if (!$this->ValidateAddress($address)) {
        $this->SetError($this->Lang('invalid_address').': '. $address);
        if ($this->exceptions) {
          throw new phpmailerException($this->Lang('invalid_address').': '.$address);
        }
!       if ($this->SMTPDebug) {
!         $this->edebug($this->Lang('invalid_address').': '.$address);
        }
        return false;
      }
***************
*** 551,575 ****
  
    /**
     * Check that a string looks roughly like an email address should
!    * Static so it can be used without instantiation
!    * Tries to use PHP built-in validator in the filter extension (from PHP 5.2), falls back to a reasonably competent regex validator
!    * Conforms approximately to RFC2822
!    * @link http://www.hexillion.com/samples/#Regex Original pattern found here
     * @param string $address The email address to check
     * @return boolean
     * @static
     * @access public
     */
    public static function ValidateAddress($address) {
!     if (function_exists('filter_var')) { //Introduced in PHP 5.2
!       if(filter_var($address, FILTER_VALIDATE_EMAIL) === FALSE) {
!         return false;
!       } else {
!         return true;
!       }
      } else {
!       return preg_match('/^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9_](?:[a-zA-Z0-9_\-](?!\.)){0,61}[a-zA-Z0-9_-]?\.)+[a-zA-Z0-9_](?:[a-zA-Z0-9_\-](?!$)){0,61}[a-zA-Z0-9_]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/', $address);
!     }
    }
  
    /////////////////////////////////////////////////
--- 719,749 ----
  
    /**
     * Check that a string looks roughly like an email address should
!    * Static so it can be used without instantiation, public so people can overload
!    * Conforms to RFC5322: Uses *correct* regex on which FILTER_VALIDATE_EMAIL is
!    * based; So why not use FILTER_VALIDATE_EMAIL? Because it was broken to
!    * not allow a@b type valid addresses :(
!    * Some Versions of PHP break on the regex though, likely due to PCRE, so use
!    * the older validation method for those users. (http://php.net/manual/en/pcre.installation.php)
!    * @link http://squiloople.com/2009/12/20/email-address-validation/
!    * @copyright regex Copyright Michael Rushton 2009-10 | http://squiloople.com/ | Feel free to use and redistribute this code. But please keep this copyright notice.
     * @param string $address The email address to check
     * @return boolean
     * @static
     * @access public
     */
    public static function ValidateAddress($address) {
! 	if ((defined('PCRE_VERSION')) && (version_compare(PCRE_VERSION, '8.0') >= 0)) {
! 	  return preg_match('/^(?!(?>(?1)"?(?>\\\[ -~]|[^"])"?(?1)){255,})(?!(?>(?1)"?(?>\\\[ -~]|[^"])"?(?1)){65,}@)((?>(?>(?>((?>(?>(?>\x0D\x0A)?[	 ])+|(?>[	 ]*\x0D\x0A)?[	 ]+)?)(\((?>(?2)(?>[\x01-\x08\x0B\x0C\x0E-\'*-\[\]-\x7F]|\\\[\x00-\x7F]|(?3)))*(?2)\)))+(?2))|(?2))?)([!#-\'*+\/-9=?^-~-]+|"(?>(?2)(?>[\x01-\x08\x0B\x0C\x0E-!#-\[\]-\x7F]|\\\[\x00-\x7F]))*(?2)")(?>(?1)\.(?1)(?4))*(?1)@(?!(?1)[a-z0-9-]{64,})(?1)(?>([a-z0-9](?>[a-z0-9-]*[a-z0-9])?)(?>(?1)\.(?!(?1)[a-z0-9-]{64,})(?1)(?5)){0,126}|\[(?:(?>IPv6:(?>([a-f0-9]{1,4})(?>:(?6)){7}|(?!(?:.*[a-f0-9][:\]]){7,})((?6)(?>:(?6)){0,5})?::(?7)?))|(?>(?>IPv6:(?>(?6)(?>:(?6)){5}:|(?!(?:.*[a-f0-9]:){5,})(?8)?::(?>((?6)(?>:(?6)){0,3}):)?))?(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])(?>\.(?9)){3}))\])(?1)$/isD', $address);
! 	} elseif (function_exists('filter_var')) { //Introduced in PHP 5.2
!         if(filter_var($address, FILTER_VALIDATE_EMAIL) === FALSE) {
!           return false;
!         } else {
!           return true;
!         }
      } else {
!         return preg_match('/^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9_](?:[a-zA-Z0-9_\-](?!\.)){0,61}[a-zA-Z0-9_-]?\.)+[a-zA-Z0-9_](?:[a-zA-Z0-9_\-](?!$)){0,61}[a-zA-Z0-9_]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/', $address);
! 	}
    }
  
    /////////////////////////////////////////////////
***************
*** 580,585 ****
--- 754,760 ----
     * Creates message and assigns Mailer. If the message is
     * not sent successfully then it returns false.  Use the ErrorInfo
     * variable to view description of the error.
+    * @throws phpmailerException
     * @return bool
     */
    public function Send() {
***************
*** 587,593 ****
        if(!$this->PreSend()) return false;
        return $this->PostSend();
      } catch (phpmailerException $e) {
! 	  $this->SentMIMEMessage = '';
        $this->SetError($e->getMessage());
        if ($this->exceptions) {
          throw $e;
--- 762,768 ----
        if(!$this->PreSend()) return false;
        return $this->PostSend();
      } catch (phpmailerException $e) {
!       $this->mailHeader = '';
        $this->SetError($e->getMessage());
        if ($this->exceptions) {
          throw $e;
***************
*** 596,604 ****
      }
    }
  
!   protected function PreSend() {
      try {
! 	  $mailHeader = "";
        if ((count($this->to) + count($this->cc) + count($this->bcc)) < 1) {
          throw new phpmailerException($this->Lang('provide_address'), self::STOP_CRITICAL);
        }
--- 771,784 ----
      }
    }
  
!   /**
!    * Prep mail by constructing all message entities
!    * @throws phpmailerException
!    * @return bool
!    */
!   public function PreSend() {
      try {
!       $this->mailHeader = "";
        if ((count($this->to) + count($this->cc) + count($this->bcc)) < 1) {
          throw new phpmailerException($this->Lang('provide_address'), self::STOP_CRITICAL);
        }
***************
*** 619,644 ****
        $this->MIMEBody = $this->CreateBody();
  
        // To capture the complete message when using mail(), create
! 	  // an extra header list which CreateHeader() doesn't fold in
        if ($this->Mailer == 'mail') {
          if (count($this->to) > 0) {
!           $mailHeader .= $this->AddrAppend("To", $this->to);
          } else {
!           $mailHeader .= $this->HeaderLine("To", "undisclosed-recipients:;");
          }
!         $mailHeader .= $this->HeaderLine('Subject', $this->EncodeHeader($this->SecureHeader(trim($this->Subject))));
          // if(count($this->cc) > 0) {
!             // $mailHeader .= $this->AddrAppend("Cc", $this->cc);
          // }
        }
  
        // digitally sign with DKIM if enabled
!       if ($this->DKIM_domain && $this->DKIM_private) {
          $header_dkim = $this->DKIM_Add($this->MIMEHeader, $this->EncodeHeader($this->SecureHeader($this->Subject)), $this->MIMEBody);
          $this->MIMEHeader = str_replace("\r\n", "\n", $header_dkim) . $this->MIMEHeader;
        }
  
-       $this->SentMIMEMessage = sprintf("%s%s\r\n\r\n%s",$this->MIMEHeader,$mailHeader,$this->MIMEBody);
        return true;
  
      } catch (phpmailerException $e) {
--- 799,823 ----
        $this->MIMEBody = $this->CreateBody();
  
        // To capture the complete message when using mail(), create
!       // an extra header list which CreateHeader() doesn't fold in
        if ($this->Mailer == 'mail') {
          if (count($this->to) > 0) {
!           $this->mailHeader .= $this->AddrAppend("To", $this->to);
          } else {
!           $this->mailHeader .= $this->HeaderLine("To", "undisclosed-recipients:;");
          }
!         $this->mailHeader .= $this->HeaderLine('Subject', $this->EncodeHeader($this->SecureHeader(trim($this->Subject))));
          // if(count($this->cc) > 0) {
!             // $this->mailHeader .= $this->AddrAppend("Cc", $this->cc);
          // }
        }
  
        // digitally sign with DKIM if enabled
!       if (!empty($this->DKIM_domain) && !empty($this->DKIM_private) && !empty($this->DKIM_selector) && !empty($this->DKIM_domain) && file_exists($this->DKIM_private)) {
          $header_dkim = $this->DKIM_Add($this->MIMEHeader, $this->EncodeHeader($this->SecureHeader($this->Subject)), $this->MIMEBody);
          $this->MIMEHeader = str_replace("\r\n", "\n", $header_dkim) . $this->MIMEHeader;
        }
  
        return true;
  
      } catch (phpmailerException $e) {
***************
*** 650,656 ****
      }
    }
  
!   protected function PostSend() {
      try {
        // Choose the mailer and send through it
        switch($this->Mailer) {
--- 829,841 ----
      }
    }
  
!   /**
!    * Actual Email transport function
!    * Send the email via the selected mechanism
!    * @throws phpmailerException
!    * @return bool
!    */
!   public function PostSend() {
      try {
        // Choose the mailer and send through it
        switch($this->Mailer) {
***************
*** 669,696 ****
        if ($this->exceptions) {
          throw $e;
        }
! 	  if ($this->SMTPDebug) {
!         echo $e->getMessage()."\n";
        }
-       return false;
      }
    }
  
    /**
     * Sends mail using the $Sendmail program.
     * @param string $header The message headers
     * @param string $body The message body
     * @access protected
     * @return bool
     */
    protected function SendmailSend($header, $body) {
      if ($this->Sender != '') {
!       $sendmail = sprintf("%s -oi -f %s -t", escapeshellcmd($this->Sendmail), escapeshellarg($this->Sender));
      } else {
        $sendmail = sprintf("%s -oi -t", escapeshellcmd($this->Sendmail));
      }
      if ($this->SingleTo === true) {
!       foreach ($this->SingleToArray as $key => $val) {
          if(!@$mail = popen($sendmail, 'w')) {
            throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
          }
--- 853,881 ----
        if ($this->exceptions) {
          throw $e;
        }
!       if ($this->SMTPDebug) {
!         $this->edebug($e->getMessage()."\n");
        }
      }
+     return false;
    }
  
    /**
     * Sends mail using the $Sendmail program.
     * @param string $header The message headers
     * @param string $body The message body
+    * @throws phpmailerException
     * @access protected
     * @return bool
     */
    protected function SendmailSend($header, $body) {
      if ($this->Sender != '') {
!       $sendmail = sprintf("%s -oi -f%s -t", escapeshellcmd($this->Sendmail), escapeshellarg($this->Sender));
      } else {
        $sendmail = sprintf("%s -oi -t", escapeshellcmd($this->Sendmail));
      }
      if ($this->SingleTo === true) {
!       foreach ($this->SingleToArray as $val) {
          if(!@$mail = popen($sendmail, 'w')) {
            throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
          }
***************
*** 726,731 ****
--- 911,917 ----
     * Sends mail using the PHP mail() function.
     * @param string $header The message headers
     * @param string $body The message body
+      * @throws phpmailerException
     * @access protected
     * @return bool
     */
